import { ConfigSetName, ConfigSetType, StageName } from "@takomo/config-sets";
import { DeploymentGroupConfig } from "@takomo/deployment-targets-config";
import { DeploymentTargetsContext } from "@takomo/deployment-targets-context";
import { DeploymentGroupPath, DeploymentTargetNamePattern, Label } from "@takomo/deployment-targets-model";
import { ConfigSetExecutionGroup, ConfigSetExecutionPlan } from "@takomo/execution-plans";
import { CommandPath } from "@takomo/stacks-model";
import { TkmLogger } from "@takomo/util";
import { PlannedDeploymentTarget } from "./model";
export declare type ExecutionGroupConverter = (group: DeploymentGroupConfig, stageName: StageName) => ConfigSetExecutionGroup<PlannedDeploymentTarget>;
export interface TargetsSelectionCriteria {
    readonly groups: ReadonlyArray<DeploymentGroupPath>;
    readonly targets: ReadonlyArray<DeploymentTargetNamePattern>;
    readonly excludeTargets: ReadonlyArray<DeploymentTargetNamePattern>;
    readonly labels: ReadonlyArray<Label>;
    readonly excludeLabels: ReadonlyArray<Label>;
    readonly configSetType: ConfigSetType;
    readonly configSetName?: ConfigSetName;
    readonly commandPath?: CommandPath;
}
export interface CreateExecutionPlanProps {
    readonly ctx: DeploymentTargetsContext;
    readonly logger: TkmLogger;
    readonly targetsSelectionCriteria: TargetsSelectionCriteria;
    readonly executionGroupConverter: ExecutionGroupConverter;
}
export declare const createConfigSetExecutionPlan: ({ ctx, targetsSelectionCriteria, executionGroupConverter, }: CreateExecutionPlanProps) => ConfigSetExecutionPlan<PlannedDeploymentTarget>;
