"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getExecutionRoleArn = void 0;
const aws_model_1 = require("@takomo/aws-model");
const getExecutionRoleArn = (configSetType, callerIdentity, target) => {
    const accountId = target.accountId ?? callerIdentity.accountId;
    switch (configSetType) {
        case "bootstrap":
            if (target.bootstrapRole) {
                return target.bootstrapRole.iamRoleArn;
            }
            if (target.bootstrapRoleName) {
                return (0, aws_model_1.makeIamRoleArn)(accountId, target.bootstrapRoleName);
            }
            return undefined;
        case "standard":
            if (target.deploymentRole) {
                return target.deploymentRole.iamRoleArn;
            }
            if (target.deploymentRoleName) {
                return (0, aws_model_1.makeIamRoleArn)(accountId, target.deploymentRoleName);
            }
            return undefined;
        default:
            throw new Error(`Unsupported config set type: ${configSetType}`);
    }
};
exports.getExecutionRoleArn = getExecutionRoleArn;
//# sourceMappingURL=get-execution-role-arn.js.map