"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.planDeployment = void 0;
const config_set_execution_plan_1 = require("../common/plan/config-set-execution-plan");
const confirm_1 = require("./confirm");
const skippedResult = (timer, outputFormat) => ({
    timer,
    outputFormat,
    results: [],
    success: true,
    status: "SKIPPED",
    message: "No targets to deploy",
});
const planDeployment = async (holder) => {
    const { ctx, io, input, timer } = holder;
    const plan = await (0, config_set_execution_plan_1.createExecutionPlan)({
        ctx,
        logger: io,
        targetsSelectionCriteria: input,
    });
    if (plan.stages.length === 0) {
        timer.stop();
        io.info("No targets to deploy");
        return skippedResult(timer, input.outputFormat);
    }
    return (0, confirm_1.confirmOperation)({
        ...holder,
        plan,
    });
};
exports.planDeployment = planDeployment;
//# sourceMappingURL=plan.js.map